# MBD-ChessAnalysis

## Content

The goal of this project is to analyse the capitalization of people on blunders in chess games, and the different in computer/human chess performance. 

## Data
The data used for this project consisted from the {Lichess open database}[https://database.lichess.org/] and the {CCRL-40/15 Computer Games Dataset}[https://computerchess.org.uk/ccrl/4040/index.html]

## Scripts
This is an overview of all the scripts used in this project and their purpose for our research.
<ul>
    <li><b>parsing/ccrl_rdd_parse.py</b> - Used to parse the CCRL-40/15 compressed PGN dataset into an RDD, with each game being annotated with a monotonically increasing ID, prefixed by the partition's ID. The RDD is then saved on the HDFS as a text file</li>
    <li><b>parsing/ccrl_parse.py</b> - Used to parse the CCRL-40/15 dataset from a comma separated text-file to a dataframe which is then saved as a CSV file.</li>
    <li><b>metrics/metrics.py</b> - Used to compute relevant metrics from both the Lichess dataset and the CCRL-40/15 dataset. It uses UDF's and Regex to extract relevant information from PGN notations. The output is saved as a parquet file on the HDFS. The output is used for subsequent analysis since it is about 10x smaller in size. </li>
    <li><b>metrics/median_dcm.py</b> - Used to compute the median DCM values for all the human & computer games.</li>
    <li><b>metrics/blunders_per_type.py</b> - Used to compute the number of blunders per piece type for all human games.</li>
    <li><b>metrics/BlunderCapitalization.py</b> - Used to compute blunder metrics after X amount of moves.</li>
    <li><b>visualization/*</b> - Scripts used to create the visualizations used in the report</li>
</ul>


## Authors and acknowledgment

This project was done for the Managing Big Data course at the University of Twente.

Group members:

- O.K. Jansen
- M.N. Van Veen
- V.I. Goşa
- J.E. Sweers
- T. Veurink
